<template>
  <div class="criterion-form-item">
    <el-form-item
      v-if="(question.ShowQuestion === 1 && !!~question.ParentTriggerValueList.indexOf(questionForm[question.ParentId])) || question.ShowQuestion === 0"
      :label="`${question.QuestionName}`" :prop="question.Id" :title="question.Remark" :rules="[
        {
          required: (question.IsRequired === 0 || (question.IsRequired === 1 && question.RelevanceId && !!~question.RelevanceValueList.indexOf(questionForm[question.RelevanceId]))) && question.Type !== 'group' && question.Type !== 'summary',
          message: $t('common:ruleMessage:select'), trigger: ['blur', 'change']
        },
        {
          validator: question.Type === 'number' && !question.TypeValue ? validatorNumberInput : (rule, value, callback) => { callback() },
          trigger: ['blur', 'change']
        }
      ]" :class="[question.Type === 'group' ? 'mb' : question.Type === 'upload' ? 'uploadWrapper' : '']">
      <!-- 输入框 -->
      <el-input v-if="question.Type === 'input'" v-model="questionForm[question.Id]"
        :disabled="question.TableQuestionType === 2 || (question.IsCopy && type === 'edit' && !IsBaseline && questionForm.IsCurrentTaskAdd === 'False')" />
      <!-- 多行文本输入框 -->
      <el-input v-if="question.Type === 'textarea'" v-model="questionForm[question.Id]" type="textarea"
        :disabled="question.TableQuestionType === 2 || (question.IsCopy && type === 'edit' && !IsBaseline && questionForm.IsCurrentTaskAdd === 'False')"
        :autosize="{ minRows: 2, maxRows: 4 }" />
      <!-- 下拉框 -->
      <el-select v-if="question.Type === 'select'" v-model="questionForm[question.Id]" clearable
        :disabled="(question.TableQuestionType === 2 || question.QuestionGenre === 2) || (question.IsCopy && type === 'edit' && !IsBaseline && questionForm.IsCurrentTaskAdd === 'False')"
        @change="((val) => { formItemChange(val, question) })">
        <template v-if="question.TableQuestionType === 1">
          <el-option v-for="item in organList" :key="item.Id" :label="item[question.DataTableColumn]"
            :value="item[question.DataTableColumn]" />
        </template>
        <template v-else-if="question.TableQuestionType === 3 || question.QuestionGenre === 3">
          <el-option v-for="item of $d[question.DictionaryCode]" :key="item.id" :value="item.value"
            :label="item.label" />
        </template>
        <template
          v-else-if="(question.TableQuestionType === 2 || question.QuestionGenre === 2) && question.DictionaryCode">
          <el-option v-for="item of $d[question.DictionaryCode]" :key="item.id" :value="item.value"
            :label="item.label" />
        </template>
        <template v-else>
          <el-option v-for="val in question.TypeValue.split('|')" :key="val" :label="val" :value="val" />
        </template>

      </el-select>
      <!-- 单选 -->
      <el-radio-group v-if="question.Type === 'radio'" v-model="questionForm[question.Id]"
        :disabled="question.TableQuestionType === 2 || (question.IsCopy && type === 'edit' && !IsBaseline && questionForm.IsCurrentTaskAdd === 'False')"
        @change="((val) => { formItemChange(val, question) })">
        <el-radio v-for="val in question.TypeValue.split('|')" :key="val" :label="val">
          {{ val }}
        </el-radio>
      </el-radio-group>
      <!-- 复选框 -->
      <el-checkbox-group v-if="question.Type === 'checkbox'"
        :disabled="question.TableQuestionType === 2 || (question.IsCopy && type === 'edit' && !IsBaseline && questionForm.IsCurrentTaskAdd === 'False')"
        v-model="questionForm[question.Id]">
        <el-checkbox v-for="val in question.TypeValue.split('|')" :key="val" :label="val">
          {{ val }}
        </el-checkbox>
      </el-checkbox-group>
      <!-- 自动分类 -->
      <el-input v-if="question.Type === 'class' && question.ClassifyShowType === 1"
        v-model="questionForm[question.Id]" />
      <el-select v-if="question.Type === 'class' && question.ClassifyShowType === 2" v-model="questionForm[question.Id]"
        :disabled="!question.ClassifyEditType" @change="(val) => { formItemChange(val, question) }">
        <el-option v-for="val in question.TypeValue.split('|')" :key="val" :label="val.trim()" :value="val.trim()" />
      </el-select>
      <el-radio-group v-if="question.Type === 'class' && question.ClassifyShowType === 3"
        v-model="questionForm[question.Id]" :disabled="!question.ClassifyEditType"
        @change="(val) => { formItemChange(val, question) }">
        <el-radio v-for="item of question.TypeValue.split('|')" :key="item.trim()" :label="item.trim()">
          {{ item.trim() }}
        </el-radio>
      </el-radio-group>
      <!-- 自增 -->
      <el-input v-if="question.Type === 'increment'" v-model="questionForm[question.Id]" disabled />
      <div style="display: flex;justify-content: space-between;"
        v-if="question.Type === 'number' || question.Type === 'calculation'">
        <!-- 自动计算 -->
        <!-- :precision="2" :step="0.1" :max="10" -->
        <el-input v-if="question.Type === 'calculation'" v-model="questionForm[question.Id]"
          oninput="value=value.replace(/^\D*(\d*(?:.\d{0,2})?).*$/g, '$1')" disabled />
        <!-- 数值 -->
        <!-- :precision="2" :step="0.1" :max="10" -->
        <el-select v-if="question.Type === 'number' && question.TypeValue" v-model="questionForm[question.Id]" clearable
          @change="(val) => { formItemNumberChange(val, question) }"
          :disabled="question.TableQuestionType === 2 || (question.IsCopy && type === 'edit' && !IsBaseline && questionForm.IsCurrentTaskAdd === 'False')">
          <el-option v-for="val in question.TypeValue.split('|')" :key="val" :label="val.trim()" :value="val.trim()" />
          <template v-if="question.Unit !== 0" slot="prefix">{{ question.Unit !== 4 ? $fd('ValueUnit', question.Unit) :
            question.CustomUnit }}</template>
          <template v-else-if="question.ValueType === 2" slot="prefix">%</template>
        </el-select>
        <el-input type="text" v-else-if="question.Type === 'number' && question.DataSource !== 1"
          :disabled="question.TableQuestionType === 2 || (question.IsCopy && type === 'edit' && !IsBaseline && questionForm.IsCurrentTaskAdd === 'False')"
          @change="((val) => { formItemNumberChange(val, question) })" @input="numberInput(question.Id)"
          @blur="handleBlur(questionForm[question.Id], questionForm, question.Id)"
          v-model.trim="questionForm[question.Id]">
          <template slot="append" v-if="question.Unit !== 0">{{ question.Unit !== 4 ? $fd('ValueUnit', question.Unit) :
            question.CustomUnit }}</template>
        </el-input>
        <el-input type="text" v-else-if="question.Type === 'number' && question.DataSource === 1"
          :disabled="question.DataSource === 1" @input="numberInput(question.Id, true)"
          @blur="handleCalculationBlur(calculationValue)" v-model.trim="calculationValue">
          <template slot="append" v-if="question.Unit !== 0">{{ question.Unit !== 4 ? $fd('ValueUnit', question.Unit) :
            question.CustomUnit }}</template>
        </el-input>
        <svg-icon v-if="qs.ShowChartTypeEnum > 0 && $router.currentRoute.query.isReadingTaskViewInOrder"
          icon-class="readingChart" class="svg-icon svg-readingChart" @click.stop="(e) => handleReadingChart({
            e,
            data: {
              TableQuestionId: question.Id,
              RowIndex: questionForm.RowIndex,
              QuestionName: question.QuestionName
            }
          })" />
      </div>
      <!-- 上传图像 -->
      <el-upload v-if="question.Type === 'upload'" action :accept="question.FileType"
        :limit="question.ImageCount === 0 ? 100 : question.ImageCount" :on-preview="handlePictureCardPreview"
        :before-upload="handleBeforeUpload" :http-request="uploadScreenshot" list-type="picture-card"
        :on-remove="handleRemove" :file-list="fileList"
        :class="{ disabled: question.ImageCount === 0 ? false : fileList.length >= question.ImageCount }">
        <i slot="default" class="el-icon-plus" />
        <div slot="file" slot-scope="{file}">
          <viewer :ref="file.url" :images="[imageUrl]" style="
                display: flex;
                align-items: center;
                justify-content: center;
                width: 100%;
                height: 100%;
              ">
            <img class="el-upload-list__item-thumbnail" :src="OSSclientConfig.basePath + file.url"
              crossOrigin="anonymous" alt="" style="max-width: 100%; max-height: 100%" />
            <span class="el-upload-list__item-actions">
              <span class="el-upload-list__item-preview" @click="handlePictureCardPreview(file)">
                <i class="el-icon-zoom-in" />
              </span>

              <span v-if="readingTaskState < 2" class="el-upload-list__item-delete" @click="handleRemove(file)">
                <i class="el-icon-delete" />
              </span>
            </span>
          </viewer>
        </div>
      </el-upload>
      <el-dialog v-if="question.Type === 'upload'" append-to-body :visible.sync="imgVisible" width="600px">
        <el-image :src="imageUrl" width="100%">
          <div slot="placeholder" class="image-slot">
            {{ $t('trials:readingUnit:qsList:message:loading') }}<span class="dot">...</span>
          </div>
        </el-image>
      </el-dialog>
    </el-form-item>
  </div>
</template>
<script>
import { uploadReadingAnswerImage, getTrialOrganList, getCustomTableQuestionPreview } from '@/api/trials'
export default {
  name: 'QuestionFormItem',
  props: {
    IsBaseline: {
      type: Boolean,
      required: true
    },
    questionForm: {
      type: Object,
      default() {
        return {}
      }
    },
    question: {
      type: Object,
      default() {
        return []
      }
    },
    criterionId: {
      type: String,
      required: true
    },
    CalculationList: {
      type: Array,
      default() {
        return []
      }
    },
    readingTaskState: {
      type: Number,
      required: true
    },
    visitTaskId: {
      type: String,
      default: ''
    },
    type: {
      type: String,
      default: 'add'
    }
  },
  computed: {
    calculationValue: {
      get() {
        return this.questionForm[this.question.Id]
      },
      set() {

      }
    }
  },
  data() {
    return {
      addOrEdit: { visible: false, title: '' },
      fileList: [],
      accept: '.png,.jpg,.jpeg',
      imgVisible: false,
      imageUrl: '',
      urls: [],
      organList: [],
      QuestionsList: [],
      QuestionsForm: {},
      digitPlaces: 2
    }
  },
  // watch: {
  //   questionForm: {
  //     deep: true,
  //     immediate: true,
  //     handler(v) {
  //
  //     }
  //   }
  // },
  watch: {
    questionForm: {
      deep: true,
      immediate: true,
      handler(v, oldv) {
        // try {
        //   if (!v[this.question.Id] || !oldv[this.question.Id]) return
        // } catch (e) {
        // }
        // this.formItemNumberChange(this.question.Id, false)
      }
    },
  },
  mounted() {
    var digitPlaces = Number(localStorage.getItem('digitPlaces'))
    this.digitPlaces = digitPlaces === -1 ? this.digitPlaces : digitPlaces
    if (this.question.Type === 'upload') {
      if (this.questionForm[this.question.Id]) {
        this.urls = this.questionForm[this.question.Id].split('|')
        this.fileList = []
        this.urls.map(url => {
          this.fileList.push({ name: '', url: `${url}` })
        })
      }
    }
    if (this.type === 'edit') return
    // if (this.question.Type === 'number') {
    //   console.log(this.questionForm)
    //   this.$set(this.questionForm, this.question.Id, null)
    // } else {
    //   this.$set(this.questionForm, this.question.Id, '')
    // }
  },
  methods: {
    handleReadingChart(e) {
      this.$emit('handleReadingChart', e)
    },
    numberInput(id, notId = false) {
      if (notId) {
        this.calculationValue = this.calculationValue.toUpperCase();
      } else {
        this.questionForm[id] = this.questionForm[id].toUpperCase();
      }
    },
    validatorNumberInput(rule, value, callback) {
      let reg = new RegExp(/^(?:-?(?:(?:0|[1-9]\d*)(?:\.\d+)?|\.\d+)|NE)$/, 'g')
      if (value === '') {
        callback();
      } else {
        if (!reg.test(value)) {
          callback(new Error(this.$t('trials:reading:ruleMessage:validatorNumberInput')));
        } else {
          callback();
        }
      }
    },
    save() {
    },
    openAddTableCol(row) {
      this.addOrEdit.visible = true
      this.addOrEdit.title = row.QuestionName + this.$t('trials:readingUnit:qsList:title:tableQs')
      this.QuestionsList = row.TableQuestions.Questions
      this.AnswersList = row.TableQuestions.Answers
      this.QuestionsForm = {}
      console.log(this.QuestionsForm)
    },
    getOrganInfoList() {
      var param = {
        trialId: this.$route.query.trialId,
        lesionType: this.question.LesionType,
        isEnable: true
      }
      getTrialOrganList(param).then(res => {
        this.organList = res.Result
      })
    },
    formItemChange(v, question) {
      if (question.Childrens && question.Childrens.length > 0) {
        this.resetChild(question.Childrens)
      }
      if (question.TableQuestionType === 1 && question.RelationQuestions.length > 0) {
        var index = this.organList.findIndex(item => item[question.DataTableColumn] === v)
        if (index < 0) return
        var selected = this.organList[index]
        this.question.RelationQuestions.map(qs => {
          var val = selected[qs.DataTableColumn]
          // if (typeof val === 'boolean') {
          //   // val = String(val)
          // }
          this.$emit('setFormItemData', { key: qs.Id, val: val, question: qs })
        })
      } else {
        this.$emit('setFormItemData', { key: question.Id, val: v, question: question })
      }
    },
    handleBlur(value, a, b) {
      if (!value) return false
      if (!isNaN(parseFloat(value))) {
        this.$set(a, b, parseFloat(value).toFixed(this.digitPlaces))
      }
      // this.$set(a, b, parseFloat(value).toFixed(this.digitPlaces))
    },
    handleCalculationBlur(v) {
      if (!v) return false
      if (!isNaN(parseFloat(v))) {
        this.calculationValue = parseFloat(v).toFixed(this.digitPlaces)
      }
    },
    limitInput(value, q) {
      console.log(value)
      if (value.indexOf('.') > -1) {
        if (value.split('.')[1].length >= this.digitPlaces) {
          this.$set(this.questionForm, q.Id, parseFloat(value).toFixed(this.digitPlaces))
        }
      } else {
      }
    },
    logic(rules, num = 0) {
      let isNE = false
      try {
        if (rules.CalculateQuestionList.length === 0) {
          return false
        }
        let dataArr = []
        var count = 0
        var maxList = [], minList = []
        rules.CalculateQuestionList.forEach((o, i) => {
          if (this.questionForm[o.TableQuestionId] === 'NE') {
            isNE = true
          }
          if (rules.CustomCalculateMark > 4 && rules.CustomCalculateMark < 10) {
            if (i !== 0) {
              switch (rules.CustomCalculateMark) {
                case 7:
                  if (!isNaN(parseFloat(this.questionForm[o.TableQuestionId]))) {
                    count += parseFloat(this.questionForm[o.TableQuestionId])
                  }
                  if (i === rules.CalculateQuestionList.length - 1) {
                    num = count / rules.CalculateQuestionList.length
                  }
                  break;
                case 8:
                  if (!isNaN(parseFloat(this.questionForm[o.TableQuestionId]))) {
                    maxList.push(this.questionForm[o.TableQuestionId])
                  }

                  if (i === rules.CalculateQuestionList.length - 1) {
                    num = Math.max(...maxList)
                  }
                  break;
                case 9:
                  if (!isNaN(parseFloat(this.questionForm[o.TableQuestionId]))) {
                    minList.push(this.questionForm[o.TableQuestionId])
                  }

                  if (i === rules.CalculateQuestionList.length - 1) {
                    num = Math.min(...minList)
                  }
                  break;
              }
            } else {
              if (!isNaN(parseFloat(this.questionForm[o.TableQuestionId]))) {
                maxList.push(this.questionForm[o.TableQuestionId])
                minList.push(this.questionForm[o.TableQuestionId])
                count = parseFloat(this.questionForm[o.TableQuestionId])
                num = parseFloat(this.questionForm[o.TableQuestionId])
                dataArr.push(num)
              }

            }
          } else {
            if (i !== 0) {
              switch (rules.CustomCalculateMark) {
                case 1:
                  if (!isNaN(parseFloat(this.questionForm[o.TableQuestionId]))) {
                    num += parseFloat(this.questionForm[o.TableQuestionId])
                  }

                  break;
                case 2:
                  if (!isNaN(parseFloat(this.questionForm[o.TableQuestionId]))) {
                    num -= parseFloat(this.questionForm[o.TableQuestionId])
                  }

                  break;
                case 3:
                  if (!isNaN(parseFloat(this.questionForm[o.TableQuestionId]))) {
                    num *= parseFloat(this.questionForm[o.TableQuestionId])
                  }

                  break;
                case 4:
                  if (!isNaN(parseFloat(this.questionForm[o.TableQuestionId]))) {
                    if (parseFloat(this.questionForm[o.TableQuestionId]) === 0) {
                      num = 0
                    } else {
                      num /= parseFloat(this.questionForm[o.TableQuestionId])
                    }
                  }

                  break;
                case 10:
                  if (!isNaN(parseFloat(this.questionForm[o.TableQuestionId]))) {
                    dataArr.push(parseFloat(this.questionForm[o.TableQuestionId]))
                  }
                  num = dataArr.length === 0 ? 0 : dataArr.reduce((acc, curr) => {
                    return acc + (typeof curr === "number" ? curr : 0);
                  }, 0) / dataArr.length;
                  break;
                case 11:
                  if (!isNaN(parseFloat(this.questionForm[o.TableQuestionId]))) {
                    dataArr.push(parseFloat(this.questionForm[o.TableQuestionId]))
                  }
                  num = Math.max(...dataArr);
                  break;
                case 12:
                  if (!isNaN(parseFloat(this.questionForm[o.TableQuestionId]))) {
                    dataArr.push(parseFloat(this.questionForm[o.TableQuestionId]))
                  }
                  num = Math.min(...dataArr);
                  break;
              }
            } else {
              num = parseFloat(this.questionForm[o.TableQuestionId])
            }
          }
        })
      } catch (e) {
        console.log(e)
      }
      if (isNE) {
        return 'NE'
      }
      if (rules.ValueType === 2) {
        num = num * 100
      }
      return num.toFixed(this.digitPlaces)
    },
    formItemNumberChange(v, question) {
      this.$emit('formItemTableNumberChange')
      this.$emit('setFormItemData', { key: question.Id, val: v, question: question })
      // this.$emit('formItemTableNumberChange', v, question)
    },
    resetChild(obj) {
      obj.forEach(i => {
        this.$emit('resetFormItemData', i.Id)
        if (i.Childrens && i.Childrens.length > 0) {
          this.resetChild(i.Childrens)
        }
      })
    },
    resetFormItemData(v) {
      this.$emit('resetFormItemData', v)
    },
    setFormItemData(obj) {
      this.$emit('setFormItemData', obj)
    },
    async uploadScreenshot(param) {
      if (!this.visitTaskId) return
      const loading = this.$loading({
        target: document.querySelector('.el-dialog'),
        fullscreen: false,
        lock: true,
        text: 'Loading',
        spinner: 'el-icon-loading'
      })
      var trialId = this.$route.query.trialId
      var subjectId = this.$route.query.trialId
      var file = await this.fileToBlob(param.file)
      const res = await this.OSSclient.put(`/${trialId}/Read/${subjectId}/${this.visitTaskId}/${param.file.name}`, file)
      console.log(res)
      this.fileList.push({ name: param.file.name, path: this.$getObjectName(res.url), url: this.$getObjectName(res.url) })
      this.urls.push(this.$getObjectName(res.url))
      this.$emit('setFormItemData', { key: this.question.Id, val: this.urls.length > 0 ? this.urls.join('|') : '', question: this.question })
      loading.close()
    },
    handleBeforeUpload(file) {
      // 检测文件类型是否符合要求
      if (this.checkFileSuffix(file.name)) {
        // this.fileList = []
        return true
      } else {
        let msg = this.$t(
          "trials:readingUnit:qsList:message:imageFormat"
        ).replace("xxx", this.question.FileType)
        this.$alert(msg)
        return false
      }
    },
    checkFileSuffix(fileName) {
      var index = fileName.lastIndexOf('.')
      var suffix = fileName.substring(index + 1, fileName.length)
      if (this.question.FileType.toLocaleLowerCase().search(suffix.toLocaleLowerCase()) === -1) {
        return false
      } else {
        return true
      }
    },
    // 预览图片
    handlePictureCardPreview(file) {
      var suffix = file.url.substring(file.url.lastIndexOf(".") + 1)
      suffix = suffix ? suffix.toLowerCase() : ''
      if (suffix === 'doc' || suffix === 'docx' || suffix === 'pdf') {
        window.open(this.OSSclientConfig.basePath + file.url, '_blank')
      } else {
        this.imageUrl = this.OSSclientConfig.basePath + file.url
        // this.imgVisible = true
        this.$refs[file.url].$viewer.show()
      }

    },
    // 删除图片
    handleRemove(file, fileList) {
      this.imageUrl = ''
      this.fileList.splice(this.fileList.findIndex(f => f.url === file.url), 1)
      this.urls.splice(this.fileList.findIndex(f => f === file.url), 1)
      this.$emit('setFormItemData', { key: this.question.Id, val: this.urls.length > 0 ? this.urls.join('|') : '', question: this.question })
    }
  }
}
</script>
<style lang="scss" scoped>
.my_dialog {
  .criterion-form-item {
    ::v-deep .el-form-item__content {
      width: auto;
    }
  }
}

::v-deep .el-select .el-input__prefix {
  left: calc(100% - 50px);
  cursor: pointer;
}

::v-deep .el-select .el-input__inner {
  padding-left: 15px;
  padding-right: 50px;
}

.criterion-form-item {
  .el-form-item {
    display: flex;
    flex-direction: row;
    align-items: flex-start;
  }

  ::v-deep .el-form-item__content {
    width: 500px;
  }

  .el-input {
    width: 100%;
  }

  .mb {
    margin-bottom: 0px;
  }

  .disabled {
    ::v-deep .el-upload--picture-card {
      display: none;
    }
  }

  .uploadWrapper {
    display: flex;
    flex-direction: column;
    align-items: flex-start;
  }
}
</style>
